package com.neo.smartobjects;

public abstract class SmartObject {

  private boolean autocommit;
  private boolean clean;
  private int id;
  String tableName = "<none>";

  protected void setTableName(String tableName) {
    this.tableName = tableName;
  }

  protected String getTableName() {
    return this.tableName;
  }

  public boolean isAutoCommit() {
    return autocommit;
  }

  public void setAutoCommit(boolean state) {
    autocommit = state;
  }

  public boolean isClean() {
    return clean;
  }

  protected void setClean(boolean state) {
    clean = state;
  }

  protected void setID(int id) {
    this.id = id;
  }

  public int getID() {
    return id;
  }

  protected void propertyChanged()
          throws SmartObjectException {
    ObjectFactory.notifyPropertyChanged(this);
  }
}